QGIS Application - Feature request #243
Add a feature to calculate field values in attribut tables
2006-08-21 06:21 AM - Redmine Admin

Status: Closed

Priority: Low

Assignee: Gary Sherman

Category: Data Provider

Pull Request or Patch supplied: Resolution: fixed
Easy fix?: No Copied to github as #: 10302
Description

Add a feature to calculate field values in attribut tables

History

#1 - 2006-08-21 02:27 PM - Gavin Macaulay -

Can you provide some more details on what you mean?

#2 - 2006-08-21 11:51 PM - Redmine Admin

Often | need to calculate new field values based on existing layer attribute table fields. For this issue it would be great if | do have a field calculator. Think
about the following situation:

. open layer attribute table.

. start digitizing.

.add a new field NEWFIELD to the opened attribute table if you don't like to overwrite existing table field values.

1
2
3
4. select the field you want to calculate values for. In our case NEWFIELD.
5. open the field calculator. (Opening the field calculator via button like the add field button).

6. select a math function to calculate the NEWFIELD value. p.e. NEWFIELD = sin(EXISTINGFIELD1) + cos(EXISTINGFIELD2)
7. stop digitizing.

Please let me know whether my details do explain my idea.

#3 - 2007-07-21 09:27 PM - Tim Sutton
Changed to minor under the following scheme:
- blocker - bugs that should block the release. Since we are going to release pretty much 'come what may' | would like no bugs
- allocated to this category without consultation with me and / or PSC
- critical - bugs that cause the application to crash or corrupt data
- major - application features that do not function at all
- minor - features that function but imerfectly e.g. labels placing incorrectly

- trivial - gui useability issues or small issues with the documentation, install notes etc.

#4 - 2008-02-12 08:02 AM - Paolo Cavallini

Looks like you want to reimplement a spreadsheet within QGIS? This can be done eg in OOo, the issue could be how to recall a spreadsheet easily
(single-click) from QGIS?

#5 - 2008-02-12 11:50 PM - Horst Diister
Replying to [comment:5 pcav]:

Looks like you want to reimplement a spreadsheet within QGIS? This can be done eg in OOo, the issue could be how to recall a spreadsheet easily
(single-click) from QGIS?

It's not the idea to reimplement a spreadsheet! But it is very helpful to calculate new column values. P.e. for Classification of objects. The first part of my

request, add a new column, is realised (PostGIS Layer)

#6 - 2008-07-03 08:05 AM - cdavilam -

Replying to [comment:5 pcav]:

Looks like you want to reimplement a spreadsheet within QGIS? This can be done eg in OOo, the issue could be how to recall a spreadsheet easily
(single-click) from QGIS?

Although it can be done in a spreadsheet, it would be very useful enabling it within QGIS. Otherwise it's necessary to remove the layer/close project->open

dbf in OOo->edit and save->reload in QGIS/reopen project->rearrange simbology (if you don't have it saved), which is a very annoying process.

#7 - 2008-07-03 08:58 AM - Paolo Cavallini

Isn't this implemented as a python plugin? Should we close this?

#8 - 2008-07-03 11:39 AM - Horst Diister

Replying to [comment:9 pcav]:

Isn't this implemented as a python plugin? Should we close this?

Which plugin do you mean?

#9 - 2009-01-31 02:48 AM - Paolo Cavallini

Table Manager, by Borys. Please check whether it has the functions you need.

#10 - 2009-01-31 11:54 AM - cdavilam -

No, it has a Calculate button, but currently not functional (to be implemented...)

#11 - 2009-01-31 03:03 PM - Borys Jurgiel

Exactly. It's on very hign position on my TODO list, but | haven't touch it yet. I'll do my best to implement it in February.

#12 - 2009-07-10 05:59 AM - Giovanni Manghi

2025-04-27 2/4



I would like also to see this feature implemented, not only because | think is useful, but also because the-rissing-of-thisteel is one of that things that (other
software) users do notice when using for the first time QGis.

#13 - 2009-07-10 07:13 AM - Horst Duster

Replying to [comment:14 lutra]:

I would like also to see this feature implemented, not only because | think is useful, but also because the-rissing-ofthisteel is one of that things that
(other software) users do notice when using for the first time QGis.

+1

#14 - 2009-07-10 08:10 AM - Martin Dobias

What operations and functions should such field calculator support?

#15 - 2009-07-10 10:33 AM - Giovanni Manghi

Replying to [comment:16 wonder]:

What operations and functions should such field calculator support?

I know that make comparisons it is always bad, but (if you want to stay out of the arc* playground) | would suggest to have a look at the "field calculator" of

gvSIG. It has many commands, every one has his own short description, so you may want to have a look to the program (I cannot find references of all the
commands, not even in the manual, pag. 220 [ftp://downloads.gvsig.org/gva/descargas/manuales/gvSIG-1_1-man-vi-en.pdf here]).

See the attached image.

Among the others you can calculate areas, perimeters and lenghts without having to create a new shapefile like ftools requires.

Command list:

ABS
ACOS
AREA
ASIN
ATAN
CEIL
COs
PERIMETER
Pl

+

POW
RANDOM
ROUND

SIN

SSQRT

TAN
TODEGREES
TONUMBER
TORADIANS
TOSTRING

#16 - 2009-07-11 12:58 AM - Marco Hugentobler

Note: a field calculator is on my (implementation) roadmap for this summer.

Marco

#17 - 2009-09-30 06:38 AM - Marco Hugentobler

- Status changed from Open to Closed
- Resolution set to fixed

A field calculator is available from

commit:59a486bd (SVN r11736) on (more operators will follow)

Marco

Files
